/************************************************************
   Alumna: Merc Jorquera Teixid
   Base de dades: Oracle 11g
   TFC: DESCARREGA D'APLICACIONS PER A MBILS INTEL.LIGENTS
   SCRIPT: Creacio_BD.sql
*************************************************************/
SET SERVEROUTPUT ON;
set echo on
spool Creacio_BD.log

--------------------------------------------------------------
-- ESBORRAR TOTES LES SEQNCIES I TOTS ELS TRIGGERS  --
--------------------------------------------------------------
drop sequence SEQ_idIdioma;
drop trigger INS_IDIOMA_idIdioma;
drop sequence SEQ_idDivisa;
drop trigger INS_DIVISA_idDivisa;
drop sequence SEQ_idPais;
drop trigger INS_PAIS_idPais;
drop sequence SEQ_idProvincia;
drop trigger INS_PROVINCIA_idProvincia;
drop sequence SEQ_idLocalitat;
drop trigger INS_LOCALITAT_idLocalitat;
drop sequence SEQ_idFormaPago;
drop trigger INS_F_PAGO_idFormaPago;
drop sequence SEQ_idRepresentant;
drop trigger INS_REPRES_idRepresentant;
drop sequence SEQ_idGrupMatriu;
drop trigger INS_GRUP_MATRIU_idGrupMatriu;
drop sequence SEQ_idOperador;
drop trigger INS_OPERADORS_idOperador;
drop sequence SEQ_idUsuari;
drop trigger INS_USUARIS_idUsuari;
drop sequence SEQ_idDesenv;
drop trigger INS_DESENVOLUPADOR_idDesenv;
drop sequence SEQ_idFabricant;
drop trigger INS_FABRICANT_idFabricant;
drop sequence SEQ_idModel;
drop trigger INS_MODEL_DISPOSITIU_idModel;
drop sequence SEQ_idSSOO;
drop trigger INS_SSOO_idSSOO;
drop sequence SEQ_idCategoria;
drop trigger INS_CATEGORIA_idCategoria;
drop sequence SEQ_idAplicacio;
drop trigger INS_APLICACIO_idAplicacio;
drop sequence SEQ_idDescripcio;
drop trigger INS_DESCRIPCIO_idDescripcio;
drop sequence SEQ_idDispositiu;
drop trigger INS_DISPOSITIU_idDispositiu;
drop sequence SEQ_codiProducte;
drop trigger INS_PRODUCTE_codiProducte;
drop sequence SEQ_idAutor;
drop trigger INS_AUTOR_idAutor;
drop sequence SEQ_idPreus;
drop trigger INS_PREUS_idPreus;
drop sequence SEQ_idDescarrega;
drop trigger INS_DESCARREGA_idDescarrega;
drop sequence SEQ_idVerHis;
drop trigger INS_VERSIONS_HIST_idVerHis;
drop sequence SEQ_idVideo;
drop trigger INS_VIDEO_idVideo;
drop sequence SEQ_idLog;
drop trigger INS_LOGS_idLog;



--------------------------------------------------------------
-- ESBORRAR TOTES LES TAULES  --
--------------------------------------------------------------

DROP TABLE APLICACIO CASCADE CONSTRAINTS ;
DROP TABLE AUTOR CASCADE CONSTRAINTS ;
DROP TABLE CATEGORIA CASCADE CONSTRAINTS ;
DROP TABLE DESCARREGA CASCADE CONSTRAINTS ;
DROP TABLE DESCRIPCIO CASCADE CONSTRAINTS ;
DROP TABLE DESENVOLUPADOR CASCADE CONSTRAINTS ;
DROP TABLE DISPOSITIU CASCADE CONSTRAINTS ;
DROP TABLE DIVISA CASCADE CONSTRAINTS ;
DROP TABLE ESTADISTICA_12 CASCADE CONSTRAINTS ;
DROP TABLE ESTADISTICA_345 CASCADE CONSTRAINTS ;
DROP TABLE ESTADISTICA_678 CASCADE CONSTRAINTS ;
DROP TABLE FABRICANT CASCADE CONSTRAINTS ;
DROP TABLE FORMA_PAGO CASCADE CONSTRAINTS ;
DROP TABLE GRUP_MATRIU CASCADE CONSTRAINTS ;
DROP TABLE IDIOMA CASCADE CONSTRAINTS ;
DROP TABLE LOCALITAT CASCADE CONSTRAINTS ;
DROP TABLE LOGS CASCADE CONSTRAINTS ;
DROP TABLE MODEL_DISPOSITIU CASCADE CONSTRAINTS ;
DROP TABLE OPERADORS CASCADE CONSTRAINTS ;
DROP TABLE PAIS CASCADE CONSTRAINTS ;
DROP TABLE PREUS CASCADE CONSTRAINTS ;
DROP TABLE PRODUCTE CASCADE CONSTRAINTS ;
DROP TABLE PROVINCIA CASCADE CONSTRAINTS ;
DROP TABLE REPRESENTANT CASCADE CONSTRAINTS ;
DROP TABLE SSOO CASCADE CONSTRAINTS ;
DROP TABLE USUARIS CASCADE CONSTRAINTS ;
DROP TABLE VERSIONS_HIST CASCADE CONSTRAINTS ;
DROP TABLE VIDEO CASCADE CONSTRAINTS ;



---------------------------------------------------------------------------------
-- CREACI DE TAULES --
---------------------------------------------------------------------------------

------------------------------
-- Taula IDIOMA 
------------------------------
CREATE TABLE IDIOMA 
    ( 
     idIdioma 		NUMBER  	NOT NULL , 
     nomIdioma 		VARCHAR2 (12)   NOT NULL ,
     CONSTRAINT IDIOMA_PK PRIMARY KEY (idIdioma) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula DIVISA 
------------------------------
CREATE TABLE DIVISA 
    ( 
     idDivisa 		NUMBER  	NOT NULL , 
     nomDivisa 		VARCHAR2 (30)  	NOT NULL , 
     nomISO4217 	VARCHAR2 (3)  	NOT NULL ,
     CONSTRAINT DIVISA_PK PRIMARY KEY (idDivisa) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT DIVISA__UN UNIQUE (nomISO4217) USING INDEX TABLESPACE APPS_INDEXS 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula PAIS 
------------------------------
CREATE TABLE PAIS 
    ( 
     idPais 	NUMBER  	NOT NULL , 
     codiISO 	VARCHAR2 (2)  	NOT NULL , 
     nomPais 	VARCHAR2 (30) , 
     idIdioma 	NUMBER  	NOT NULL , 
     idDivisa 	NUMBER  	NOT NULL ,
     CONSTRAINT Pais_PK PRIMARY KEY (idPais) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT PAIS__UN UNIQUE (codiISO) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PAIS_DIVISA_FK FOREIGN KEY (idDivisa) REFERENCES DIVISA (idDivisa) ,
     CONSTRAINT PAIS_IDIOMA_FK FOREIGN KEY (idIdioma) REFERENCES IDIOMA (idIdioma) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula PROVINCIA 
------------------------------
CREATE TABLE PROVINCIA 
    ( 
     idProvincia 	NUMBER  	NOT NULL , 
     nomProvincia 	VARCHAR2 (50)   NOT NULL , 
     idPais 		NUMBER  	NOT NULL ,
     CONSTRAINT PROVINCIA_PK PRIMARY KEY (idProvincia) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PROVINCIA_PAIS_FK FOREIGN KEY (idPais) REFERENCES PAIS (idPais) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula LOCALITAT 
------------------------------
CREATE TABLE LOCALITAT 
    ( 
     idLocalitat 	NUMBER  	NOT NULL , 
     nomLocalitat 	VARCHAR2 (60)   NOT NULL , 
     idProvincia 	NUMBER  	NOT NULL ,
     CONSTRAINT LOCALITAT_PK PRIMARY KEY (idLocalitat) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT LOCALITAT_PROVINCIA_FK FOREIGN KEY (idProvincia) REFERENCES PROVINCIA (idProvincia) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula FORMA_PAGO 
------------------------------
CREATE TABLE FORMA_PAGO 
    ( 
     idFormaPago 	NUMBER  	NOT NULL , 
     nomFormaPago 	VARCHAR2 (50)   NOT NULL ,
     CONSTRAINT FORMA_PAGO_PK PRIMARY KEY (idFormaPago) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;



------------------------------
-- Taula REPRESENTANT 
------------------------------
CREATE TABLE REPRESENTANT 
    ( 
     idRepresentant 	NUMBER  	NOT NULL , 
     nom 		VARCHAR2 (30)  	NOT NULL , 
     cognom1 		VARCHAR2 (30) , 
     cognom2 		VARCHAR2 (30) , 
     nif 		VARCHAR2 (9)  	NOT NULL , 
     adreca 		VARCHAR2 (70)  	NOT NULL , 
     idLocalitat 	NUMBER  	NOT NULL , 
     codiPostal 	VARCHAR2 (5)   	NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT REPRESENTANT_PK PRIMARY KEY (idRepresentant) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT REPRESENTANT__UN_NIF UNIQUE (nif) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT REPRESENTANT_LOCALITAT_FK FOREIGN KEY (idLocalitat) REFERENCES LOCALITAT (idLocalitat) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula GRUP_MATRIU 
------------------------------
CREATE TABLE GRUP_MATRIU 
    ( 
     idGrupMatriu 	NUMBER  	 NOT NULL , 
     nomGrupMatriu 	VARCHAR2 (70) 	 NOT NULL , 
     codiIdent 		VARCHAR2 (20) 	 NOT NULL , 
     adreca 		VARCHAR2 (70)    NOT NULL , 
     idLocalitat 	NUMBER   	NOT NULL , 
     codiPostal 	VARCHAR2 (5)    NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT GRUP_MATRIU_PK PRIMARY KEY (idGrupMatriu) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT GRUP_MATRIU__UN_CODIIDENT UNIQUE (codiIdent) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula OPERADORS 
------------------------------
CREATE TABLE OPERADORS 
    ( 
     idOperador 	NUMBER  	NOT NULL , 
     nomOperador 	VARCHAR2 (70)  	NOT NULL , 
     codiIdent 		VARCHAR2 (20)  	NOT NULL , 
     idPaisRegistre 	NUMBER  	NOT NULL , 
     idGrupMatriu 	NUMBER  	NOT NULL , 
     adreca 		VARCHAR2 (70)  	NOT NULL , 
     idLocalitat 	NUMBER  	NOT NULL , 
     codiPostal 	VARCHAR2 (5)    NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT OPERADORS_PK PRIMARY KEY (idOperador) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT OPERADORS__UN_CODIIDENT UNIQUE (codiIdent) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT OPERADORS_GRUP_MATRIU_FK FOREIGN KEY (idGrupMatriu) REFERENCES GRUP_MATRIU (idGrupMatriu) ,
     CONSTRAINT OPERADORS_LOCALITAT_FK FOREIGN KEY (idLocalitat) REFERENCES LOCALITAT (idLocalitat) ,
     CONSTRAINT OPERADORS_PAIS_FK FOREIGN KEY (idPaisRegistre)   REFERENCES PAIS (idPais) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula USUARIS 
------------------------------
CREATE TABLE USUARIS 
    ( 
     idUsuari 		NUMBER  	NOT NULL , 
     nomUsuari 		VARCHAR2 (70)  	NOT NULL , 
     cognom1 		VARCHAR2 (30) , 
     cognom2 		VARCHAR2 (30) , 
     nif 		VARCHAR2 (9)  	NOT NULL , 
     numTelefon 	VARCHAR2 (9) 	NOT NULL  CHECK (LENGTH(NUMTELEFON) = 9) , 
     adreca 		VARCHAR2 (70) 	NOT NULL , 
     idLocalitat 	NUMBER  	NOT NULL , 
     codiPostal 	VARCHAR2 (5)    NOT NULL , 
     idPaisRegistre 	NUMBER  	NOT NULL , 
     eMail 		VARCHAR2 (70)  	NOT NULL , 
     idOperador 	NUMBER  	NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT USUARIS_PK PRIMARY KEY (idUsuari) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT USUARIS__UN_NIF UNIQUE (nif) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT USUARIS__UN_TELEFON UNIQUE (numTelefon) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT USUARIS_PAIS_FK FOREIGN KEY (idPaisRegistre) REFERENCES PAIS (idPais) ,
     CONSTRAINT USUARIS_LOCALITAT_FK FOREIGN KEY (idLocalitat) REFERENCES LOCALITAT (idLocalitat) ,
     CONSTRAINT USUARIS_OPERADORS_FK FOREIGN KEY (idOperador) REFERENCES OPERADORS (idOperador) 
    ) 
TABLESPACE APPS_DADES;



------------------------------
-- Taula DESENVOLUPADOR 
------------------------------
CREATE TABLE DESENVOLUPADOR 
    ( 
     idDesenv 		NUMBER  	NOT NULL , 
     nomDesen 		VARCHAR2 (70)  	NOT NULL , 
     codiIdent 		VARCHAR2 (20) 	NOT NULL , 
     adreca 		VARCHAR2 (70)  	NOT NULL , 
     idlocalitat 	NUMBER  	NOT NULL , 
     codiPostal 	VARCHAR2 (5)    NOT NULL , 
     numTel 		VARCHAR2 (9)  	NOT NULL  CHECK (LENGTH(numTel) = 9) , 
     paginaWeb 		VARCHAR2 (250)   NOT NULL , 
     eMail 		VARCHAR2 (150)  	NOT NULL , 
     idPaisRegistre 	NUMBER  		NOT NULL , 
     IdRepresentant 	NUMBER  		NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT DESENVOLUPADOR_PK PRIMARY KEY (idDesenv) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DESENVOLUPADOR__UN_CODIIDENT UNIQUE (codiIdent) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DESENVOLUPADOR_LOCALITAT_FK FOREIGN KEY (idlocalitat) REFERENCES LOCALITAT (idLocalitat), 
     CONSTRAINT DESENVOLUPADOR_PAIS_FK FOREIGN KEY (idPaisRegistre) REFERENCES PAIS (idPais) ,
     CONSTRAINT DESENVOLUPADOR_REPRESENTANT_FK FOREIGN KEY (IdRepresentant) REFERENCES REPRESENTANT (idRepresentant) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula FABRICANT 
------------------------------
CREATE TABLE FABRICANT 
    ( 
     idFabricant 	NUMBER  	NOT NULL , 
     nomFabricant 	VARCHAR2 (70)  	NOT NULL , 
     codiIdent 		VARCHAR2 (20)  	NOT NULL , 
     adreca 		VARCHAR2 (70) 	NOT NULL , 
     idLocalitat 	NUMBER  	NOT NULL , 
     codiPostal 	VARCHAR2 (5)    NOT NULL , 
     dataEstat 		DATE , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) ,
     CONSTRAINT FABRICANT_PK PRIMARY KEY ( idFabricant ) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT FABRICANT__UN_CODIIDENT UNIQUE (codiIdent) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT FABRICANT_LOCALITAT_FK FOREIGN KEY (idLocalitat) REFERENCES LOCALITAT (idLocalitat) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula MODEL_DISPOSITIU
------------------------------
CREATE TABLE MODEL_DISPOSITIU 
    ( 
     idModel 		NUMBER  	NOT NULL , 
     nomModel 		VARCHAR2 (40)   NOT NULL , 
     idFabricant 	NUMBER  	NOT NULL ,
     CONSTRAINT MODEL_DISPOSITIU_PK PRIMARY KEY (idModel) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT MODEL_DISPOSITIU_FABRICANT_FK FOREIGN KEY (idFabricant) REFERENCES FABRICANT (idFabricant) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula SSOO 
------------------------------
CREATE TABLE SSOO 
    ( 
     idSSOO 	NUMBER  	 NOT NULL , 
     nomSSOO 	VARCHAR2 (30) 	 NOT NULL ,
     CONSTRAINT SSOO_PK PRIMARY KEY (idSSOO) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;
------------------------------
-- Taula CATEGORIA 
------------------------------
CREATE TABLE CATEGORIA 
    ( 
     idCategoria       NUMBER          NOT NULL , 
     nomCategoria      VARCHAR2 (50)   NOT NULL ,
     CONSTRAINT CATEGORIA_PK PRIMARY KEY (idCategoria) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT CATEGORIA__UN_NOM_CATE UNIQUE (nomCategoria) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula APLICACIO 
------------------------------
CREATE TABLE APLICACIO 
    ( 
     idAplicacio        NUMBER         NOT NULL , 
     nomApli            VARCHAR2 (70)  NOT NULL , 
     idCategoria        NUMBER         NOT NULL ,
     CONSTRAINT APLICACIO_PK PRIMARY KEY (idAplicacio) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT APLICACIO_CATEGORIA_FK FOREIGN KEY (idCategoria) REFERENCES CATEGORIA (idCategoria),
     CONSTRAINT APLICACIO__UN_NOM_APLI UNIQUE (nomApli) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula DESCRIPCIO 
------------------------------
CREATE TABLE DESCRIPCIO 
    ( 
     idDescripcio      NUMBER          NOT NULL , 
     idAplicacio       NUMBER          NOT NULL , 
     idIdioma          NUMBER          NOT NULL , 
     descripcio        VARCHAR2 (2000)  NOT NULL ,
     CONSTRAINT DESCRIPCIO__IDX PRIMARY KEY (idDescripcio) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DESCRIPCIO__UN_APLI_IDIO UNIQUE (idAplicacio,idIdioma) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DESCRIPCIO_APLICACIO_FK FOREIGN KEY (idAplicacio) REFERENCES APLICACIO (idAplicacio) ,
     CONSTRAINT DESCRIPCIO_IDIOMA_FK FOREIGN KEY (idIdioma) REFERENCES IDIOMA (idIdioma) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula DISPOSITIU 
------------------------------
CREATE TABLE DISPOSITIU 
    ( 
     idDispositiu 	NUMBER  	NOT NULL , 
     idUsuari 		NUMBER          NOT NULL , 
     codiIMEI 		VARCHAR2 (15) 	NOT NULL CHECK (LENGTH(codiIMEI) = 15) , 
     idModel 		NUMBER  	NOT NULL , 
     idSSOO 		NUMBER  	NOT NULL , 
     versioSSOO 	VARCHAR2 (15) , 
     resolucio 		VARCHAR2 (30)  	NOT NULL , 
     idIdiomaDisp 	NUMBER  	NOT NULL , 
     estat 		VARCHAR2 (1) DEFAULT 'A' CHECK ( estat IN ('A', 'B')) , 
     dataEstat 		DATE ,
     CONSTRAINT DISPOSITIU_PK PRIMARY KEY (idDispositiu) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DISPOSITIU__UN_IMEI UNIQUE (codiIMEI) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT DISPOSITIU_IDIOMA_FK FOREIGN KEY (idIdiomaDisp) REFERENCES IDIOMA (idIdioma) ,
     CONSTRAINT DISPOSITIU_MODEL_DISPOSITIU_FK FOREIGN KEY (idModel) REFERENCES MODEL_DISPOSITIU (idModel) ,
     CONSTRAINT DISPOSITIU_SSOO_FK FOREIGN KEY (idSSOO) REFERENCES SSOO (idSSOO) ,
     CONSTRAINT DISPOSITIU_USUARIS_FK FOREIGN KEY (idUsuari) REFERENCES USUARIS (idUsuari) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula PRODUCTE 
------------------------------
CREATE TABLE PRODUCTE 
    ( 
     codiProducte 	NUMBER  	NOT NULL , 
     idAplic 		NUMBER  	NOT NULL , 
     idSSOO 		NUMBER 	 	NOT NULL , 
     versio 		VARCHAR2 (5)	NOT NULL , 
     enllaFitxer 	VARCHAR2 (1000)  NOT NULL , 
     midaAplic 		VARCHAR2 (50)  	NOT NULL , 
     dataPujada 	DATE  		NOT NULL , 
     resolucio 		VARCHAR2 (50)  	NOT NULL , 
     estatVersio 	VARCHAR2 (1) DEFAULT 'A'  NOT NULL CHECK ( estatVersio IN ('A', 'I')) ,
     CONSTRAINT PRODUCTE_PK PRIMARY KEY (codiProducte) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PRODUCTE__UNAPL_SO_VERSIO UNIQUE (idAplic,idSSOO,versio) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PRODUCTE__UN_ENLLAS UNIQUE (enllaFitxer) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PRODUCTE_APLICACIO_FK FOREIGN KEY (idAplic) REFERENCES APLICACIO (idAplicacio) ,
     CONSTRAINT PRODUCTE_SSOO_FK FOREIGN KEY (idSSOO) REFERENCES SSOO (idSSOO) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula AUTOR 
------------------------------
CREATE TABLE AUTOR 
    ( 
     idAutor            NUMBER         NOT NULL , 
     idProd             NUMBER         NOT NULL , 
     idDesev            NUMBER         NOT NULL ,
     CONSTRAINT AUTOR_PK PRIMARY KEY (idAutor) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT AUTOR__UN_PROD_DESEN UNIQUE (idProd,idDesev) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT AUTOR_DESENVOLUPADOR_FK FOREIGN KEY (idDesev) REFERENCES DESENVOLUPADOR (idDesenv),
     CONSTRAINT AUTOR_PRODUCTE_FK FOREIGN KEY (idProd) REFERENCES PRODUCTE (codiProducte) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula PREUS 
------------------------------
CREATE TABLE PREUS 
    ( 
     idPreus 		NUMBER  NOT NULL , 
     idProducte 	NUMBER  NOT NULL , 
     idPais 		NUMBER  NOT NULL , 
     preuAplic 		NUMBER  NOT NULL , 
     idDivisa 		NUMBER  NOT NULL ,
     CONSTRAINT PREUS_PK PRIMARY KEY (idPreus) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PREUS__UN_PRO_PAIS UNIQUE (idProducte,idPais) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT PREUS_DIVISA_FK FOREIGN KEY (idDivisa) REFERENCES DIVISA (idDivisa) ,
     CONSTRAINT PREUS_PAIS_FK FOREIGN KEY (idPais) REFERENCES PAIS (idPais) ,
     CONSTRAINT PREUS_PRODUCTE_FK FOREIGN KEY (idProducte) REFERENCES PRODUCTE (codiProducte) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula DESCARREGA 
------------------------------
CREATE TABLE DESCARREGA 
    ( 
     idDescarrega         NUMBER    NOT NULL , 
     dataDesc             DATE      NOT NULL , 
     idProducte           NUMBER    NOT NULL , 
     idDispositiu         NUMBER    NOT NULL , 
     idUsuari             NUMBER    NOT NULL , 
     idOpDes              NUMBER    NOT NULL , 
     idPaisRegUsu         NUMBER    NOT NULL , 
     preuPagat            NUMBER    NOT NULL , 
     idDivisa             NUMBER    NOT NULL , 
     idPagament           NUMBER    NOT NULL ,
     CONSTRAINT DESCARREGA_PK PRIMARY KEY (idDescarrega) USING INDEX TABLESPACE APPS_INDEXS,
     CONSTRAINT DESCARREGA_DISPOSITIU_FK FOREIGN KEY (idDispositiu) REFERENCES DISPOSITIU (idDispositiu) ,
     CONSTRAINT DESCARREGA_DIVISA_FK FOREIGN KEY (idDivisa) REFERENCES DIVISA (idDivisa) ,
     CONSTRAINT DESCARREGA_FORMA_PAGO_FK FOREIGN KEY (idPagament) REFERENCES FORMA_PAGO (idFormaPago) ,
     CONSTRAINT DESCARREGA_OPERADORS_FK FOREIGN KEY (idOpDes) REFERENCES OPERADORS (idOperador) ,
     CONSTRAINT DESCARREGA_PRODUCTE_FK FOREIGN KEY (idProducte) REFERENCES PRODUCTE (codiProducte) ,
     CONSTRAINT DESCARREGA_Pais_FK FOREIGN KEY (idPaisRegUsu) REFERENCES PAIS (idPais) ,
     CONSTRAINT DESCARREGA_USUARIS_FK FOREIGN KEY (idUsuari) REFERENCES USUARIS (idUsuari) 
    ) 
TABLESPACE APPS_DADES;

------------------------------
-- Taula VERSIONS_HIST 
------------------------------
CREATE TABLE VERSIONS_HIST 
    ( 
     idVerHis 		NUMBER  NOT NULL , 
     idProducte 	NUMBER  NOT NULL , 
     dataInici 		DATE  	NOT NULL , 
     dataFi 		DATE  	,
     CONSTRAINT VERSIONS_HIST_PK PRIMARY KEY (idVerHis) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT VERSIONS_HIST_PRODUCTE_FK FOREIGN KEY (idProducte) REFERENCES PRODUCTE (codiProducte) 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula VIDEO 
------------------------------
CREATE TABLE VIDEO 
    ( 
     idVideo 		NUMBER  	NOT NULL , 
     idProducte 	NUMBER  	NOT NULL , 
     idIdioma 		NUMBER  	NOT NULL , 
     enllaVideo 	VARCHAR2 (300)  NOT NULL ,
     CONSTRAINT VIDEO_PK PRIMARY KEY (idVideo) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT VIDEO__UN_PRO_IDIOMA UNIQUE ( idProducte , idIdioma ) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT VIDEO_IDIOMA_FK FOREIGN KEY (idIdioma) REFERENCES IDIOMA (idIdioma) ,
     CONSTRAINT VIDEO_PRODUCTE_FK FOREIGN KEY (idProducte) REFERENCES PRODUCTE (codiProducte)
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula ESTADISTICA_12
------------------------------
CREATE TABLE ESTADISTICA_12 
    ( 
     totalDescarregues 	NUMBER , 
     totalDiners 	NUMBER 
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula ESTADISTICA_345
------------------------------

CREATE TABLE ESTADISTICA_345 
    ( 
     anyo 		NUMBER 	NOT NULL , 
     mitjaDescUsu 	NUMBER , 
     desenvMaxDesc 	VARCHAR2 (200) , 
     numDescDesen 	NUMBER , 
     aplicMesRecaptat 	VARCHAR2 (70) , 
     desenvMesRecaptat 	VARCHAR2 (200) ,
     CONSTRAINT ESTADISTICA_345_PK PRIMARY KEY (anyo) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula ESTADISTICA_678
------------------------------
CREATE TABLE ESTADISTICA_678 
    ( 
     anyo 		NUMBER  NOT NULL , 
     idPais 		NUMBER  NOT NULL , 
     numUsuMinDes 	NUMBER , 
     ingressosAnyPais 	NUMBER , 
     numAplicMinDes 	NUMBER ,
     CONSTRAINT ESTADISTICA_678_PK PRIMARY KEY (anyo,idPais) USING INDEX TABLESPACE APPS_INDEXS ,
     CONSTRAINT ESTADISTICA_678_PAIS_FK FOREIGN KEY (idPais) REFERENCES PAIS (idPais)
    ) 
TABLESPACE APPS_DADES;


------------------------------
-- Taula LOGS 
------------------------------
CREATE TABLE LOGS 
    ( 
     idLog 		NUMBER  	NOT NULL , 
     datahoraLog 	VARCHAR2 (50)  	NOT NULL , 
     procediment 	VARCHAR2 (250)  NOT NULL , 
     paramIn 		VARCHAR2 (1000) NOT NULL , 
     paramOut 		VARCHAR2 (1000) NOT NULL ,
     CONSTRAINT LOGS_PK PRIMARY KEY (idLog) USING INDEX TABLESPACE APPS_INDEXS
    ) 
TABLESPACE APPS_DADES;



---------------------------------------------------------------------------------
-- CREACI DE LES SEQNCIES I TRIGGERS  --
---------------------------------------------------------------------------------


------------------------------------------------------
--SEQNCIA I TRIGGER PER idIdioma DE LA TAULA IDIOMA
------------------------------------------------------

CREATE SEQUENCE SEQ_idIdioma INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_IDIOMA_idIdioma
 BEFORE INSERT ON IDIOMA
 FOR EACH ROW
BEGIN
 SELECT SEQ_idIdioma.NEXTVAL INTO :NEW.idIdioma
 FROM DUAL;
END INS_IDIOMA_idIdioma;
/
-------------------------------------------------------
--SEQNCIA I TRIGGER PER idDivisa DE LA TAULA DIVISA 
-------------------------------------------------------

CREATE SEQUENCE SEQ_idDivisa INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_DIVISA_idDivisa
 BEFORE INSERT ON DIVISA 
 FOR EACH ROW
BEGIN
 SELECT SEQ_idDivisa.NEXTVAL INTO :NEW.idDivisa
 FROM DUAL;
END INS_DIVISA_idDivisa;
/

------------------------------------------------------
--SEQNCIA I TRIGGER PER idPais DE LA TAULA PAIS 
------------------------------------------------------

CREATE SEQUENCE SEQ_idPais INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_PAIS_idPais
 BEFORE INSERT ON PAIS 
 FOR EACH ROW
BEGIN
 SELECT SEQ_idPais.NEXTVAL INTO :NEW.idPais
 FROM DUAL;
END INS_PAIS_idPais;
/

------------------------------------------------------------
--SEQNCIA I TRIGGER PER idProvincia DE LA TAULA PROVINCIA
------------------------------------------------------------

CREATE SEQUENCE SEQ_idProvincia INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_PROVINCIA_idProvincia
 BEFORE INSERT ON PROVINCIA
 FOR EACH ROW
BEGIN
 SELECT SEQ_idProvincia.NEXTVAL INTO :NEW.idProvincia
 FROM DUAL;
END INS_PROVINCIA_idProvincia;
/

-----------------------------------------------------------
--SEQNCIA I TRIGGER PER idLocalitat DE LA TAULA LOCALITAT
-----------------------------------------------------------

CREATE SEQUENCE SEQ_idLocalitat INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_LOCALITAT_idLocalitat
 BEFORE INSERT ON LOCALITAT
 FOR EACH ROW
BEGIN
 SELECT SEQ_idLocalitat.NEXTVAL INTO :NEW.idLocalitat
 FROM DUAL;
END INS_LOCALITAT_idLocalitat;
/

-------------------------------------------------------------
--SEQNCIA I TRIGGER PER idFormaPago DE LA TAULA FORMA_PAGO
-------------------------------------------------------------

CREATE SEQUENCE SEQ_idFormaPago INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_F_PAGO_idFormaPago
 BEFORE INSERT ON FORMA_PAGO
 FOR EACH ROW
BEGIN
 SELECT SEQ_idFormaPago.NEXTVAL INTO :NEW.idFormaPago
 FROM DUAL;
END INS_F_PAGO_idFormaPago;
/

------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idRepresentant DE LA TAULA REPRESENTANT
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idRepresentant INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_REPRES_idRepresentant
 BEFORE INSERT ON REPRESENTANT
 FOR EACH ROW
BEGIN
 SELECT SEQ_idRepresentant.NEXTVAL INTO :NEW.idRepresentant
 FROM DUAL;
END INS_REPRES_idRepresentant;
/

------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idGrupMatriu DE LA TAULA GRUP_MATRIU
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idGrupMatriu INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_GRUP_MATRIU_idGrupMatriu
 BEFORE INSERT ON GRUP_MATRIU
 FOR EACH ROW
BEGIN
 SELECT SEQ_idGrupMatriu.NEXTVAL INTO :NEW.idGrupMatriu
 FROM DUAL;
END INS_GRUP_MATRIU_idGrupMatriu;
/

------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idOperador DE LA TAULA OPERADORS
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idOperador INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_OPERADORS_idOperador
 BEFORE INSERT ON OPERADORS
 FOR EACH ROW
BEGIN
 SELECT SEQ_idOperador.NEXTVAL INTO :NEW.idOperador
 FROM DUAL;
END INS_OPERADORS_idOperador;
/


------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idUsuari DE LA TAULA USUARIS
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idUsuari INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_USUARIS_idUsuari
 BEFORE INSERT ON USUARIS
 FOR EACH ROW
BEGIN
 SELECT SEQ_idUsuari.NEXTVAL INTO :NEW.idUsuari
 FROM DUAL;
 :NEW.ESTAT := 'A';
-- :NEW.DATAESTAT := SYSDATE;
END INS_USUARIS_idUsuari;
/

------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idDesenv DE LA TAULA DESENVOLUPADOR
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idDesenv INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_DESENVOLUPADOR_idDesenv
 BEFORE INSERT ON DESENVOLUPADOR
 FOR EACH ROW
BEGIN
 SELECT SEQ_idDesenv.NEXTVAL INTO :NEW.idDesenv
 FROM DUAL;
 :NEW.ESTAT := 'A';
 :NEW.DATAESTAT := SYSDATE;
END INS_DESENVOLUPADOR_idDesenv;
/

------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idFabricant DE LA TAULA FABRICANT
------------------------------------------------------------------

CREATE SEQUENCE SEQ_idFabricant INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_FABRICANT_idFabricant
 BEFORE INSERT ON FABRICANT
 FOR EACH ROW
BEGIN
 SELECT SEQ_idFabricant.NEXTVAL INTO :NEW.idFabricant
 FROM DUAL;
END INS_FABRICANT_idFabricant;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idModel DE LA TAULA MODEL_DISPOSITIU
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idModel INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_MODEL_DISPOSITIU_idModel
 BEFORE INSERT ON MODEL_DISPOSITIU
 FOR EACH ROW
BEGIN
 SELECT SEQ_idModel.NEXTVAL INTO :NEW.idModel
 FROM DUAL;
END INS_MODEL_DISPOSITIU_idModel;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idSSOO DE LA TAULA SSOO
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idSSOO INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_SSOO_idSSOO
 BEFORE INSERT ON SSOO
 FOR EACH ROW
BEGIN
 SELECT SEQ_idSSOO.NEXTVAL INTO :NEW.idSSOO
 FROM DUAL;
END INS_SSOO_idSSOO;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idCategoria DE LA TAULA CATEGORIA
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idCategoria INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_CATEGORIA_idCategoria
 BEFORE INSERT ON CATEGORIA
 FOR EACH ROW
BEGIN
 SELECT SEQ_idCategoria.NEXTVAL INTO :NEW.idCategoria
 FROM DUAL;
END INS_CATEGORIA_idCategoria;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idAplicacio DE LA TAULA APLICACIO
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idAplicacio INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_APLICACIO_idAplicacio
 BEFORE INSERT ON APLICACIO
 FOR EACH ROW
BEGIN
 SELECT SEQ_idAplicacio.NEXTVAL INTO :NEW.idAplicacio
 FROM DUAL;
END INS_APLICACIO_idAplicacio;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idDescripcio DE LA TAULA DESCRIPCIO
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idDescripcio INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_DESCRIPCIO_idDescripcio
 BEFORE INSERT ON DESCRIPCIO
 FOR EACH ROW
BEGIN
 SELECT SEQ_idDescripcio.NEXTVAL INTO :NEW.idDescripcio
 FROM DUAL;
END INS_DESCRIPCIO_idDescripcio;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idDispositiu DE LA TAULA DISPOSITIU
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idDispositiu INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_DISPOSITIU_idDispositiu
 BEFORE INSERT ON DISPOSITIU
 FOR EACH ROW
BEGIN
 SELECT SEQ_idDispositiu.NEXTVAL INTO :NEW.idDispositiu
 FROM DUAL;
 :NEW.ESTAT := 'A';
 :NEW.DATAESTAT := SYSDATE;
END INS_DISPOSITIU_idDispositiu;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER codiProducte DE LA TAULA PRODUCTE
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_codiProducte INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_PRODUCTE_codiProducte
 BEFORE INSERT ON PRODUCTE
 FOR EACH ROW
BEGIN
 SELECT SEQ_codiProducte.NEXTVAL INTO :NEW.codiProducte
 FROM DUAL;
-- :NEW.DATAPUJADA := SYSDATE;
 :NEW.ESTATVERSIO := 'A';
END INS_PRODUCTE_codiProducte;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idAutor DE LA TAULA AUTOR
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idAutor INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_AUTOR_idAutor
 BEFORE INSERT ON AUTOR
 FOR EACH ROW
BEGIN
 SELECT SEQ_idAutor.NEXTVAL INTO :NEW.idAutor
 FROM DUAL;
END INS_AUTOR_idAutor;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idPreus DE LA TAULA PREUS
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idPreus INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_PREUS_idPreus
 BEFORE INSERT ON PREUS
 FOR EACH ROW
BEGIN
 SELECT SEQ_idPreus.NEXTVAL INTO :NEW.idPreus
 FROM DUAL;
SELECT DIVISA.IDDIVISA INTO :NEW.IdDivisa FROM DIVISA WHERE NOMISO4217 ='EUR';
END INS_PREUS_idPreus;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idDescarrega DE LA TAULA DESCARREGA
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idDescarrega INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_DESCARREGA_idDescarrega
 BEFORE INSERT ON DESCARREGA
 FOR EACH ROW
BEGIN
 SELECT SEQ_idDescarrega.NEXTVAL INTO :NEW.idDescarrega
 FROM DUAL;
-- :NEW.DATADESC := SYSDATE;
 SELECT DIVISA.IDDIVISA INTO :NEW.idDivisa FROM DIVISA  WHERE NOMISO4217 ='EUR';
END INS_DESCARREGA_idDescarrega;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idVerHis DE LA TAULA VERSIONS_HIST
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idVerHis INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_VERSIONS_HIST_idVerHis
 BEFORE INSERT ON VERSIONS_HIST
 FOR EACH ROW
BEGIN
 SELECT SEQ_idVerHis.NEXTVAL INTO :NEW.idVerHis
 FROM DUAL;
END INS_VERSIONS_HIST_idVerHis;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idVerHis DE LA TAULA VIDEO
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idVideo INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_VIDEO_idVideo
 BEFORE INSERT ON VIDEO
 FOR EACH ROW
BEGIN
 SELECT SEQ_idVideo.NEXTVAL INTO :NEW.idVideo
 FROM DUAL;
END INS_VIDEO_idVideo;
/

-------------------------------------------------------------------
--SEQNCIA I TRIGGER PER idLog DE LA TAULA LOGS
-------------------------------------------------------------------

CREATE SEQUENCE SEQ_idLog INCREMENT BY 1 START WITH 1 NOCACHE;

CREATE OR REPLACE TRIGGER INS_LOGS_idLog
 BEFORE INSERT ON LOGS
 FOR EACH ROW
BEGIN
 SELECT SEQ_idLog.NEXTVAL INTO :NEW.idLog
 FROM DUAL;
 :NEW.DATAHORALOG := SYSDATE;
END INS_LOGS_idLog;
/
spool OFF



