/************************************************************
   Alumna: Merc Jorquera Teixid
   Base de dades: Oracle 11g
   TFC: DESCARREGA D'APLICACIONS PER A MBILS INTEL.LIGENTS
   SCRIPT: 11-JOC_PROVES_ABM.sql
*************************************************************/
set echo on
spool JOC_PROVES_ABM.log

---------------------------
--USUARIS   -- ALTA USUARIS
---------------------------

--  PARAMETRES ENTRADA:  a_nomusuari, a_cognom1, a_cognom2, a_nif, a_numtelefon, a_adreca, a_idlocalitat, 
--				 a_codipostal, a_idpaisregistre, a_email, a_idoperador, a_dataestat

DECLARE

   RSP VARCHAR2(500);

BEGIN

-- ERROR: PAIS DE REGISTRE OPERADOR <> PAIS DE REGISTRE USUARI
-- RSP: ALTA_USUARI ERROR: PAIS DE REGISTRE OPERADOR/USUARI INCORRECTE 1: User-Defined Exception

	alta_usuari('MARTA','TEIXIDO','LLINAS','87985470E','649586800','AV. LLEIDA, 49 2-1',3,'25004',1,'MTL@gmail.com',6, '01/01/2011',RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: ALTA_USUARI ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."USUARIS"."NIF")

	alta_usuari('JUDITH','RODES','BLANCO',NULL,'678234078','AV. LLEIDA, 49 3-1',3,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: ALTA_USUARI ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.USUARIS_LOCALITAT_FK) violated - parent key not found

	alta_usuari('JUDITH','RODES','BLANCO','43589674A','678234078','AV. LLEIDA, 49 3-1',9999,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: DNI)
-- RSP: ALTA_USUARI ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.USUARIS__UNV1) violated

	alta_usuari('JUDITH','RODES','BLANCO','40985488E','678234078','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: TELEFON)  
-- RSP: ALTA_USUARI ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.USUARIS__UNV2) violated

	alta_usuari('JUDITH','RODES','BLANCO','40985477V','649000011','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VALOR INCORRECTE, LA LLARGADA DEL TELEFON ES INCORRECTA
-- RSP: ALTA_USUARI  ERROR: EL NUMERO DE TELEFON HA DE TENIR 9 DIGITS 1: User-Defined Exception

	alta_usuari('JUDITH','RODES','BLANCO','40985477V','6490055555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);	
      DBMS_OUTPUT.PUT_LINE(RSP);

--  ALTA CORRECTA
--  RSP: OK

	alta_usuari('JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
      COMMIT;

-- ERROR: NO POT HAVER-HI USUARIS DUPLICATS
-- RSP: ALTA_USUARI ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.USUARIS__UNV1) violated
	
	alta_usuari('JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'01/01/2011',RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

----------------------------------
--USUARIS   -- MODIFICACIO USUARIS
----------------------------------

--   PARAMETRES ENTRADA:  m_idusuari, m_nomusuari, m_cognom1, m_cognom2, m_nif, m_numtelefon, m_adreca, 
--                        m_idlocalitat, m_codipostal, m_idpaisregistre, m_email, m_idoperador,m_estat

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;

BEGIN

      SELECT idusuari INTO N FROM USUARIS WHERE NIF= '40985477V';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 

-- ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL
-- RSP: MODIF_USUARI  ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL  1: User-Defined Exception

  	  MODIF_USUARI(NULL,'JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@HOTMAIL.com',2,'A',RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
		
-- ERROR: L'USUARI  NO EXISTEIX
-- RSP: MODIF_USUARI ERROR: USUARI NO EXISTEIX 100: ORA-01403: no data found

	  MODIF_USUARI(66666,'JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@HOTMAIL.com',2,'A',RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);
 
-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: MODIF_USUARI ERROR ! -1407: ORA-01407: cannot update ("APPS"."USUARIS"."NIF") to NULL

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO',NULL,'649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: MODIF_USUARI ERROR: PAIS DE REGISTRE OPERADOR/USUARI INCORRECTE 1: User-Defined Exception

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',9999,'JRB@gmail.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: DNI)
-- RSP: MODIF_USUARI ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.USUARIS__UNV1) violated

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985490X','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: L'ESTAT NO POT SER DIFERENT DE 'A' (ALTA)
-- RSP: MODIF_USUARI ERROR: ESTAT NOMS POT SER A (ALTA) 1: User-Defined Exception

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'b',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

--  MODFICACIO CORRECTA
--  RSP: OK
	
       UPDATE USUARIS SET ESTAT ='B' WHERE IDUSUARI = N;
	 COMMIT;
	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985477V','649005555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@HOTMAIL.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);


-- ERROR: (CLAU UNICA: TELEFON)  
-- RSP: MODIF_USUARI ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.USUARIS__UNV2) violated

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985477V','649000014','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VALOR INCORRECTE, LA LLARGADA DEL TELEFON ES INCORRECTA
-- RSP: MODIF_USUARI ERROR: EL NUMERO DE TELEFON HA DE TENIR 9 DIGITS 1: User-Defined Exception

	 MODIF_USUARI(N,'JUDITH','RODES','BLANCO','40985477V','64900555555','AV. LLEIDA, 49 3-1',1,'25004',1,'JRB@gmail.com',2,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
----------------------------------
--USUARIS   -- BAIXA USUARIS
----------------------------------

-- PARAMETRES ENTRADA:  b_idusuari

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   X NUMBER;
   P NUMBER;	
BEGIN

      SELECT idusuari INTO N FROM USUARIS WHERE NIF= '40985477V';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 

-- ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL
-- RSP: BAIXA_USUARI  ERROR: EL PARAMETRE ENTRADA CODI USUARI NO POT SER NULL 1: User-Defined Exception

	BAIXA_USUARI(NULL,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: USUARI NO EXISTEIX
-- RSP: BAIXA_USUARI  ERROR: USUARI NO EXISTEIX 100: ORA-01403: no data found

	BAIXA_USUARI(99999,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: USUARI JA ESTA EN ESTAT DE BAIXA (INACTIU)
-- RSP: BAIXA_USUARI  ERROR: USUARI INACTIU 1: User-Defined Exception

      UPDATE USUARIS SET ESTAT ='B' WHERE IDUSUARI = N;
      COMMIT;
	BAIXA_USUARI(N,RSP);
	COMMIT;
      DBMS_OUTPUT.PUT_LINE(RSP);
      UPDATE USUARIS SET ESTAT ='A' WHERE IDUSUARI = N;
      COMMIT;

-- BAIXA CORRECTA USUARI SENSE DESCARREGUES ASSOCIADES (ESBORRA DE LA TAULA USUARIS)
-- RSP: OK

	BAIXA_USUARI(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA USUARI AMB DESCARREGUES ASSOCIADES (CANVIA L'ESTAT A BAIXA) 
-- RSP: OK

      ALTA_USUARI('PROVA','BAIXA','AMB DESCARREGUES','B1111111X','671111111','C/. PROVADOR, 5',3,'25010',1,'PROVAB@hotmail.com',1, '01/01/2011',RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
      COMMIT;
      SELECT idusuari INTO N FROM USUARIS WHERE NIF= 'B1111111X';
      COMMIT;
      PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'358987010052XXX',7,1,'4.1','320 x 480 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
      COMMIT;
      SELECT iddispositiu INTO X FROM DISPOSITIU WHERE CODIIMEI= '358987010052XXX';
	COMMIT;
      SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE ESTATVERSIO ='A' AND rownum =1;
	COMMIT;
      ALTA_DESCARREGA(P,X,1,SYSDATE,RSP);
	COMMIT;
	BAIXA_USUARI(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
	COMMIT;
END;
/

-------------------------------------------
-- DESENVOLUPADOR   -- ALTA DESENVOLUPADOR   
-------------------------------------------

-- PARAMETRES ENTRADA:  a_nomdesen, a_codiident, a_adreca, a_idlocalitat, a_codipostal,
--                        a_numtelefon, a_paginaweb, a_email, a_idpaisregistre, a_idrepresentant

DECLARE

   RSP VARCHAR2(500);

BEGIN

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: ALTA_DESENVOLUPADOR ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."DESENVOLUPADOR"."CODIIDENT")

   ALTA_DESENVOL ('PROVA', NULL, 'C/. PROVADOR, 66',2, '25001','973259684','www.provador.com','provador@provador.com',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: ALTA_DESENVOLUPADOR ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DESENVOLUPADOR_LOCALITAT_FK) violated - parent key not found

   ALTA_DESENVOL ('PROVA', 'A11111110', 'C/. PROVADOR, 66',99999, '25001','973259684','www.provador.com','provador@provador.com',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: CODIIDENT)
-- RSP: ALTA_DESENVOLUPADOR ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DESENVOLUPADOR__UN) violated

   ALTA_DESENVOL ('PROVA BAIXA', '00884543X', 'C/. PROVADOR, 66',2, '25001','973259684','www.provador.com','provador@provador.com',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ALTA CORRECTA
-- RSP: OK

   ALTA_DESENVOL ('PROVA','A11111110', 'C/. PROVADOR, 66',2, '25001','973259684','www.provador.com','provador@provador.com',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

--------------------------------------------------
-- DESENVOLUPADOR   -- MODIFICACIO DESENVOLUPADOR   
--------------------------------------------------

-- PARAMETRES ENTRADA:  m_iddesen, m_nomdesen, m_codiident, m_adreca, m_idlocalitat, m_codipostal,
--                      m_numtelefon, m_paginaweb, m_email, m_idpaisregistre, m_idrepresentant

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;

BEGIN

   SELECT IDDESENV INTO N FROM DESENVOLUPADOR WHERE CODIIDENT ='A25884177';
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL
-- RSP: MODIF_DESENVOLUPADOR ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL  1: User-Defined Exception

	   MODIF_DESENVOL (NULL,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9,'28510','91258574','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);


-- ERROR: QUE EL DESENVOLUPADOR NO EXISTEIXI
-- RSP: MODIF_DESENVOLUPADOR ERROR: EL DESENVOLUPADOR NO EXISTEIX 100: ORA-01403: no data found
	   
	   MODIF_DESENVOL (7777,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9,'28510','91258574','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
	   DBMS_OUTPUT.PUT_LINE(RSP);
		
-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: MODIF_DESENVOLUPADOR ERROR ! -1407: ORA-01407: cannot update ("APPS"."DESENVOLUPADOR"."NOMDESEN") to NULL

	   MODIF_DESENVOL (N,null,'A25884177','PASEO CASTELLANA, 87',9,'28510','912585740','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);	
	   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: MODIF_DESENVOLUPADOR ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DESENVOLUPADOR_LOCALITAT_FK) violated - parent key not found

	  MODIF_DESENVOL (N,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9999,'28510','912585740','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
	  DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: CODIIDENT)
-- RSP: MODIF_DESENVOLUPADOR ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DESENVOLUPADOR__UN) violated

	  MODIF_DESENVOL (N,'RADARDROID','00884543X','PASEO CASTELLANA, 87',9,'28510','912585740','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
	  DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: L'ESTAT NO POT SER DIFERENT DE 'A' (ALTA)
-- RSP: MODIF_DESENVOLUPADOR ERROR: ESTAT NOMS POT SER A (ALTA) 1: User-Defined Exception

	  MODIF_DESENVOL (N,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9,'28510','912585740','www.radardroid.com','radardroid@radardroid.com',1,3,'B',RSP);
        DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VALOR INCORRECTE, LA LLARGADA DEL TELEFON ES INCORRECTA
-- RSP: MODIF_DESENVOLUPADOR ERROR ! -2290: ORA-02290: check constraint (APPS.DESENVOLUPADOR_CHK1) violated

	 MODIF_DESENVOL (N,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9,'28510','91258574','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);
  
--  MODIFICACIO CORRECTA
--  RSP: OK

    	 UPDATE DESENVOLUPADOR SET ESTAT='B' WHERE IDDESENV = N;
	 COMMIT;	

       MODIF_DESENVOL (N,'RADARDROID','A25884177','PASEO CASTELLANA, 87',9,'28510','912585740','www.radardroid.com','radardroid@radardroid.com',1,3,'A',RSP);
       DBMS_OUTPUT.PUT_LINE(RSP);
	 COMMIT;

END;
/

----------------------------------------------
--DESENVOLUPADOR   -- BAIXA DESENVOLUPADOR   
----------------------------------------------

--    PARAMETRES ENTRADA:  b_iddesen

DECLARE

   RSP VARCHAR2(500);
   N  NUMBER;
BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI DESENVOLUPADOR NO POT SER NULL
-- RSP: BAIXA_DESENVOL  ERROR: EL PARAMETRE ENTRADA NO POT SER NULL  -1400: ORA-01400: cannot insert NULL into ()

	BAIXA_DESENVOL(NULL,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);


-- ERROR: DESENVOLUPADOR NO EXISTEIX
-- RSP: BAIXA_DESENVOL  ERROR: EL DESENVOLUPADOR NO EXISTEIX 100: ORA-01403: no data found

	BAIXA_DESENVOL(99999,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DESENVOLUPADOR SENSE PRODUCTES ASSOCITS (ESBORRA DE LA TAULA DESENVOLUPADOR )
-- RSP: OK

      ALTA_DESENVOL ('PROVA ESBORRA', 'A11111112', 'C/. ESBORRADOR, 77',2, '25001','973259685','www.ESBORRADOR.com','ESBORRADOR@ESBORRADOR.com',1,1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
	COMMIT;
      SELECT IDDESENV INTO N FROM DESENVOLUPADOR WHERE CODIIDENT = 'A11111112';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 
	BAIXA_DESENVOL(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DESENVOLUPADOR AMB PRODUCTES ASSOCITS (CANVIA L'ESTAT A BAIXA) 
-- RSP: OK

      ALTA_DESENVOL('PROVA BAIXA AMB PRODUCTES', 'A11111113', 'C/. BAIXA AMB PRODUCTES', 2, '25001', '973259686', 'www.baixa amb productes.co.', 'baixaambproductes@baixa.com',1,1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
	COMMIT;
      SELECT IDDESENV INTO N FROM DESENVOLUPADOR WHERE CODIIDENT = 'A11111113';
      DBMS_OUTPUT.PUT_LINE(N);
      COMMIT; 
   	PKG_ABM_AUTOR.ALTA_AUTOR(1,N,RSP);
   	DBMS_OUTPUT.PUT_LINE(RSP);
	COMMIT;
	BAIXA_DESENVOL(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: DESENVOLUPADOR JA ESTA EN ESTAT DE BAIXA (INACTIU)
-- RSP: BAIXA_DESENVOL  ERROR: DESENVOLUPADOR NO ESTIGUI JA EN ESTAT DE BAIXA 1: User-Defined Exception

	BAIXA_DESENVOL(N,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- DISPOSITIUS     -- ALTA DISPOSITIUS
-------------------------------------------

--  PARAMETRES ENTRADA:  a_idusuari, a_codiimei,a_idmodel,a_idSSOO, a_versiossoo,
--                       a_resolucio, a_ididiomadisp

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;

BEGIN

    SELECT idusuari INTO N FROM USUARIS WHERE NIF= 'I09854933';

-- ALTA CORRECTA
-- RSP: OK
	PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'358987015552199',12,2,'5','960 x 640 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);
	COMMIT;

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_DISPOSITIU  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."DISPOSITIU"."CODIIMEI")

	PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,NULL,12,2,'5','960 x 640 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_DISPOSITIU  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DISPOSITIU_MODEL_DISPOSITIU_FK) violated - parent key not found

	PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'358987010052177',122222,2,'5','960 x 640 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: CODI IMEI)
-- RSP: PKG_ABM_ALTA_DISPOSITIU  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DISPOSITIU__UN) violated

	PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'358987010052100',12,2,'5','960 x 640 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VALOR INCORRECTE, LA LLARGADA DEL CODI IMEI ES INCORRECTA
-- RSP: PKG_ABM_ALTA_DISPOSITIU  ERROR: EL EL CODI IMEI TINGUI 15 DIGITS 1: User-Defined Exception

	PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'35898701005',12,2,'5','960 x 640 pixels',1,RSP);
      DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- DISPOSITIUS-- MODIFICACIO DISPOSITIUS
-------------------------------------------

-- PARAMETRES ENTRADA:  m_iddispositiu, m_idusuari, m_codiimei, m_idmodel,m_idSSOO, 
--                      m_versiossoo, m_resolucio, m_ididiomadisp, m_estat

DECLARE

   RSP VARCHAR2(500);
   U NUMBER;
   D NUMBER;
BEGIN

   SELECT iddispositiu, idusuari INTO D,U FROM DISPOSITIU WHERE CODIIMEI= '358987015552199';

-- ERROR: EL PARAMETRE ENTRADA CODI DISPOSITIU NO POT SER NULL
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: EL PARAMETRE ENTRADA CODI DISPOSITIU NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(null,U,'358987015552199',12,2,'5','960 x 640 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL DISPOSITIU NO EXISTEIXI
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: EL DISPOSITIU NO EXISTEIX 100: ORA-01403: no data found   
	   
   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(111111,U,'358987015552199',12,2,'5','960 x 640 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
		
-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR ! -1407: ORA-01407: cannot update ("APPS"."DISPOSITIU"."IDUSUARI") to NULL

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,NULL,'358987015552199',12,2,'5','960 x 640 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DISPOSITIU_USUARIS_FK) violated - parent key not found

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,222222,'358987015552199',12,2,'5','960 x 640 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: CODI IMEI)
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DISPOSITIU__UN) violated

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,U,'358987010052100',12,2,'5','960 x 640 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: L'ESTAT NO POT SER DIFERENT DE 'A' (ALTA)
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: ESTAT NOMS POT SER A (ALTA) 1: User-Defined Exception

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,U,'358987015552199',12,2,'5','960 x 640 pixels',1,'B',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
  
-- MODFICACIO CORRECTA
-- RSP: OK
   
   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,U,'358987015552199',12,2,'5','1024 x 1024 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VALOR INCORRECTE, LA LLARGADA DEL CODI IMEI ES INCORRECTA (HA DE TENIR 15 DIGITS)
-- RSP: PKG_ABM_MODIF_DISPOSITIU  ERROR: EL EL CODI IMEI TINGUI 15 DIGITS 1: User-Defined Exception

   PKG_ABM_DISPOSITIU.MODIF_DISPOSITIU(D,U,'358987015',12,2,'5','1024 x 1024 pixels',1,'A',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
----------------------------------------------
--DISPOSITIUS      -- BAIXA DISPOSITIUS
----------------------------------------------

-- PARAMETRES ENTRADA:  m_iddispositiu

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   D NUMBER;
   P NUMBER;
BEGIN

   SELECT idusuari INTO N FROM USUARIS WHERE NIF= 'I09854933';

-- ERROR: EL PARAMETRE ENTRADA CODI DISPOSITIU NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_DISPOSITIU  ERROR: EL PARAMETRE ENTRADA CODI DISPOSITIU NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_DISPOSITIU.BAIXA_DISPOSITIU(null,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: DISPOSITIU NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_DISPOSITIU  ERROR: EL DISPOSITIU NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_DISPOSITIU.BAIXA_DISPOSITIU(11111,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DISPOSITIU SENSE DESCARREGUES ASSOCIADES (ESBORRA DE LA TAULA DISPOSITIUS )
-- RSP: OK

   PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'378987015554444',12,2,'5','960 x 640 pixels',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT iddispositiu INTO D FROM DISPOSITIU WHERE CODIIMEI= '378987015554444';
   COMMIT;
   PKG_ABM_DISPOSITIU.BAIXA_DISPOSITIU(D,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DISPOSITIU AMB DESCARREGUES ASSOCIADES (CANVIA L'ESTAT A BAIXA) 
-- RSP: OK

   PKG_ABM_DISPOSITIU.ALTA_DISPOSITIU(N,'378987015559999',12,2,'5','960 x 640 pixels',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT iddispositiu INTO D FROM DISPOSITIU WHERE CODIIMEI= '378987015559999';
   COMMIT;
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE ESTATVERSIO ='A' AND rownum =1;
   COMMIT;
   ALTA_DESCARREGA(P,D,1,SYSDATE,RSP);
   COMMIT;
   PKG_ABM_DISPOSITIU.BAIXA_DISPOSITIU(D,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: DISPOSITIU JA ESTA EN ESTAT DE BAIXA (INACTIU)
-- RSP: PKG_ABM_BAIXA_DISPOSITIU  ERROR: DISPOSITIU INACTIU 1: User-Defined Exception
 
   UPDATE DISPOSITIU SET ESTAT='B' WHERE iddispositiu = D;
   COMMIT;
   PKG_ABM_DISPOSITIU.BAIXA_DISPOSITIU(D,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- APLICACIO       -- ALTA APLICACIO
-------------------------------------------

-- PARAMETRES ENTRADA:  a_nomaplicacio, a_idcategoria

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_APLICACIO  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.APLICACIO_CATEGORIA_FK) violated - parent key not found

   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('RADARDROID',6666666,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_APLICACIO  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."APLICACIO"."IDAPLICACIO")

   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('RADARDROID PRO',NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: NOM APLICACIO)
-- RSP: PKG_ABM_ALTA_APLICACIO  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.APLICACIO__UN_NOM_APLICACIO) violated

   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('RADARDROID PRO',2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ALTA CORRECTA
-- RSP: OK
   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('APLICACIO DE PROVA',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;

END;
/

-------------------------------------------
-- APLICACIO     -- MODIFICACIO APLICACIO
-------------------------------------------

-- PARAMETRES ENTRADA:  m_idaplicacio, m_nomaplicacio, m_idcategoria

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   IDCAT NUMBER;
BEGIN

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'APLICACIO DE PROVA';
   SELECT IDCATEGORIA INTO IDCAT FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   
-- ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_APLICACIONS.MODIF_APLICACIO(null,'APLICACIO DE PROVA',IDCAT,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL APLICACIO NO EXISTEIXI
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR: APLICACIO NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_APLICACIONS.MODIF_APLICACIO(1555555,'APLICACIO DE PROVA',IDCAT,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.APLICACIO_CATEGORIA_FK) violated - parent key not found

   PKG_ABM_APLICACIONS.MODIF_APLICACIO(N,'APLICACIO DE PROVA',1111111,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR ! -1407: ORA-01407: cannot update ("APPS"."APLICACIO"."IDCATEGORIA") to NULL

   PKG_ABM_APLICACIONS.MODIF_APLICACIO(N,'APLICACIO DE PROVA',NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: NOM APLICACIO)
-- RSP: PKG_ABM_MODIF_APLICACIO  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.APLICACIO__UN_NOM_APLICACIO) violated
   
   PKG_ABM_APLICACIONS.MODIF_APLICACIO(N,'WORDS',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
-- MODIFICACIO CORRECTA
-- RSP: OK
   PKG_ABM_APLICACIONS.MODIF_APLICACIO(N,'APLICACIO DE PROVA',IDCAT,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);


END;
/


-------------------------------------------
-- APLICACIO     -- BAIXA APLICACIO
-------------------------------------------

--    PARAMETRES ENTRADA:  b_idaplicacio

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_APLICACIO  ERROR: EL PARAMETRE ENTRADA CODI APLICACIO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_APLICACIONS.BAIXA_APLICACIO(NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: APLICACIO NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_APLICACIO  ERROR: APLICACIO NO EXISTEIX 100: ORA-01403: no data found	    

   PKG_ABM_APLICACIONS.BAIXA_APLICACIO(1555555,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA APLICACIO SENSE PRODUCTES ASSOCIATS (ESBORRA DE LA TAULA APLICACIO )
-- RSP: OK

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('APLICACIO PER ESBORRAR',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'APLICACIO PER ESBORRAR';

   PKG_ABM_APLICACIONS.BAIXA_APLICACIO(N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA APLICACIO AMB PRODUCTES ASSOCIATS (NO ES POT ESBORRAR) 
-- RSP: PKG_ABM_BAIXA_APLICACIO  ERROR: APLICACIO ASSOCIADA A PRODUCTE 1: User-Defined Exception

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('APLICACIO NO ES POT ESBORRAR',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'APLICACIO NO ES POT ESBORRAR';
   COMMIT;
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.1','https://play.google.comZZZ','2,7M', '640 x 480 pixels','04/12/12',RSP);
   COMMIT;
   PKG_ABM_APLICACIONS.BAIXA_APLICACIO(N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/


-------------------------------------------
-- DESCRIPCIO       -- ALTA DESCRIPCIO       
-------------------------------------------

-- PARAMETRES ENTRADA:  a_idaplicacio, a_ididioma, a_descrip

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_DESCRIP  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DESCRIPCIO_APLICACIO_FK) violated - parent key not found
   PKG_ABM_DESCRIP.ALTA_DESCRIP (1444444,1,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_DESCRIP  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."DESCRIPCIO"."IDIDIOMA")
   PKG_ABM_DESCRIP.ALTA_DESCRIP (1,NULL,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: APLICACIO + IDIOMA)
-- RSP: PKG_ABM_ALTA_DESCRIP  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DESCRIPCIO__UN) violated
   PKG_ABM_DESCRIP.ALTA_DESCRIP (1,1,'PROVADORES',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ALTA CORRECTA
-- PKG_ABM_ALTA_DESCRIP RSP: OK

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('PROVA DESCRIPCIO',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA DESCRIPCIO';

   PKG_ABM_DESCRIP.ALTA_DESCRIP (N,1,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
END;
/

-------------------------------------------
-- DESCRIPCIO    -- MODIFICACIO DESCRIPCIO       
-------------------------------------------

-- PARAMETRES ENTRADA:  m_iddescripcio, m_idaplicacio, m_ididioma, m_descrip

DECLARE

   RSP VARCHAR2(500);
   AP NUMBER;
   D NUMBER; 
BEGIN

   SELECT IDDESCRIPCIO, IDAPLICACIO INTO D,AP FROM DESCRIPCIO WHERE descripcio = 'PROVADOR';

-- ERROR: EL PARAMETRE ENTRADA CODI DESCRIPCIO NO POT SER NULL
-- RSP: PKG_ABM_MODIF_DESCRIP  ERROR: EL PARAMETRE ENTRADA CODI DESCRIPCIO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_DESCRIP.MODIF_DESCRIP (null,AP,1,'PROVADORESSSSSS',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL DESCRIPCIO NO EXISTEIXI
-- RSP: PKG_ABM_MODIF_DESCRIP  ERROR: LA DESCRIPCIO NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_DESCRIP.MODIF_DESCRIP (15555555,AP,1,'PROVADORESSSSSS',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_DESCRIP  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.DESCRIPCIO_APLICACIO_FK) violated - parent key not found

   PKG_ABM_DESCRIP.MODIF_DESCRIP (D,14444444,1,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_DESCRIP  ERROR ! -1407: ORA-01407: cannot update ("APPS"."DESCRIPCIO"."IDAPLICACIO") to NULL

   PKG_ABM_DESCRIP.MODIF_DESCRIP (D,NULL,1,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: APLICACIO + IDIOMA)
-- RSP: PKG_ABM_MODIF_DESCRIP  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.DESCRIPCIO__UN) violated

   PKG_ABM_DESCRIP.MODIF_DESCRIP (D,AP,1,'PROVADOR',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- MODIFICACIO CORRECTA
-- RSP: OK
   PKG_ABM_DESCRIP.MODIF_DESCRIP (D,AP,1,'PROVADORSSSSS',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
END;
/

-------------------------------------------
-- DESCRIPCIO    -- BAIXA DESCRIPCIO       
-------------------------------------------

-   PARAMETRES ENTRADA:  b_iddescrip   

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI DESCRIPCIO NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_DESCRIP  ERROR: EL PARAMETRE ENTRADA CODI DESCRIPCIO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_DESCRIP.BAIXA_DESCRIP (null,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: DESCRIPCIO NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_DESCRIP  ERROR: LA DESCRIPCIO NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_DESCRIP.BAIXA_DESCRIP (1555555555,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA DESCRIPCIO (ESBORRA DE LA TAULA DESCRIPCIO )
-- RSP: OK

   SELECT IDDESCRIPCIO INTO N FROM DESCRIPCIO WHERE descripcio = 'PROVADORSSSSS';
   PKG_ABM_DESCRIP.BAIXA_DESCRIP (N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- PRODUCTE      -- ALTA PRODUCTE
-------------------------------------------

-- PARAMETRES ENTRADA:  a_idaplicacio, a_idssoo,a_versio,a_enllafitxer,a_midaaplic,
--                      a_resolucio, a_datapujada

DECLARE

   RSP VARCHAR2(500);

BEGIN

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_PRODUCTE  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.PRODUCTE_APLICACIO_FK) violated - parent key not found

   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(11111,1,'1.1','https://play.google.com/store/apps/details?id','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_PRODUCTE  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."PRODUCTE"."IDSSOO")

   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(1,NULL,'1.1','https://play.google.com/store/apps/details?id','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: APLICACIO + SSOO + VERSIO)
-- RSP: PKG_ABM_ALTA_PRODUCTE  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.PRODUCTE__UNV1) violated

   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(1,1,'1.1','https://play.google.com','3,1M', '320 x 480 pixels','01/01/2011',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: ENLLA APLICACIO)
-- RSP: PKG_ABM_ALTA_PRODUCTE  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.PRODUCTE__UNV2) violated

   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(1,1,'1.111','https://enlla_1_1_1.1','3,1M', '320 x 480 pixels','01/01/2011',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/


-------------------------------------------
-- PRODUCTE     -- MODIFICACIO PRODUCTE
-------------------------------------------

-- PARAMETRES ENTRADA:  m_idaplicacio, m_idssoo, m_versio, m_enllafitxer, m_midaaplic, m_resolucio

DECLARE

   RSP VARCHAR2(500);

BEGIN

-- ERROR: ELS PARAMETRES ENTRADA CODI APLICACIO, SSOO i VERSIO NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_PRODUCTE  ERROR: ELS PARAMETRES ENTRADA CODI APLICACIO, SSOO i VERSIO NO PODEN SER NULL  1: User-Defined Exception

   PKG_ABM_PRODUCTE.MODIF_PRODUCTE(null,1,'1.1','https://enlla_1_1_1.1','3,1M', '320 x 480 pixels',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL PRODUCTE NO EXISTEIXI
-- RSP: PKG_ABM_MODIF_PRODUCTE  ERROR: EL PRODUCTE NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_PRODUCTE.MODIF_PRODUCTE(111111111,1,'1.1','https://enlla_1_1_1.1','3,1M', '320 x 480 pixels',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_PRODUCTE  ERROR ! -1407: ORA-01407: cannot update ("APPS"."PRODUCTE"."MIDAAPLIC") to NULL

   PKG_ABM_PRODUCTE.MODIF_PRODUCTE(1,1,'1.1','https://enlla_1_1_1.1',NULL, '320 x 480 pixels',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: ENLLA)
-- RSP: PKG_ABM_MODIF_PRODUCTE  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.PRODUCTE__UN_ENLLAS) violated

   PKG_ABM_PRODUCTE.MODIF_PRODUCTE(1,1,'1.2','https://enlla_1_1_1.1','3,1M', '320 x 480 pixels',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- MODIFICACIO CORRECTA
-- RSP: OK

   PKG_ABM_PRODUCTE.MODIF_PRODUCTE(1,1,'1.1','https://enlla_1_1_1.1','1,1M', '1024 x 480 pixels',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- PRODUCTE     -- BAIXA PRODUCTE     
-------------------------------------------

-- PARAMETRES ENTRADA:  b_idaplicacio, b_idssoo, b_versio

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN


-- ERROR: ELS PARAMETRES ENTRADA CODI APLICACIO, SSOO i VERSIO NO PODEN SER NULL
-- RSP: PKG_ABM_BAIXA_PRODUCTE  ERROR: ELS PARAMETRES ENTRADA CODI APLICACIO, SSOO i VERSIO NO PODEN SER NULL  1: User-Defined Exception

   PKG_ABM_PRODUCTE.BAIXA_PRODUCTE(null,1,'1.1',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: PRODUCTE NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_PRODUCTE  ERROR: EL PRODUCTE NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_PRODUCTE.BAIXA_PRODUCTE(14444444,1,'1.1',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: L'ESTAT NO POT SER DIFERENT DE 'A' (ACTIU)
-- RSP: PKG_ABM_BAIXA_PRODUCTE  ERROR: PRODUCTE INACTIU 1: User-Defined Exception

   PKG_ABM_PRODUCTE.BAIXA_PRODUCTE(1,1,'1.1',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA PRODUCTE (CANVIA L'ESTAT A INACTIU I ACTIVA LA VERSIO ANTERIOR (SI EXISTEIX))
-- RSP: OK

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('PROVA BAIXA PRODUCTE',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA BAIXA PRODUCTE';
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.1','https://enlla_N_1_1.1','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   COMMIT;
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.2','https://enlla_N_1_1.2','3,1M', '320 x 480 pixels','01/02/2012',RSP);
   COMMIT;
   PKG_ABM_PRODUCTE.BAIXA_PRODUCTE(N,1,'1.2',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;

END;
/

-------------------------------------------
-- AUTOR     -- ALTA AUTOR     
-------------------------------------------

-- PARAMETRES ENTRADA:  a_idprod, a_iddesev

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
BEGIN

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_AUTOR  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.AUTOR_DESENVOLUPADOR_FK) violated - parent key not found

   PKG_ABM_AUTOR.ALTA_AUTOR(1,111111111,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_AUTOR  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."AUTOR"."IDDESEV")

   PKG_ABM_AUTOR.ALTA_AUTOR(1,NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + DESENVOLUPADOR)
-- RSP: PKG_ABM_ALTA_AUTOR  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.AUTOR__UN) violated

   SELECT CODIPRODUCTE INTO N FROM PRODUCTE WHERE IDAPLIC =1 AND rownum =1;	
   PKG_ABM_AUTOR.ALTA_AUTOR(N,4,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- AUTOR    -- MODIFICACIO AUTOR
-------------------------------------------

-- PARAMETRES ENTRADA:  m_idautor, m_idprod, m_iddesev

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;
BEGIN

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('PROVA MODIF AUTOR',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA MODIF AUTOR';
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.1','https://enlla_PMA_1_1.1','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   COMMIT;
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   PKG_ABM_AUTOR.ALTA_AUTOR(P,1,RSP);
   COMMIT;

   SELECT IDAUTOR INTO X FROM AUTOR WHERE IDPROD = P;

   PKG_ABM_AUTOR.ALTA_AUTOR(P,2,RSP);
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI AUTOR NO POT SER NULL
-- RSP: PKG_ABM_MODIF_AUTOR  ERROR: EL PARAMETRE ENTRADA CODI AUTOR NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_AUTOR.MODIF_AUTOR(NULL,P,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE L'AUTOR NO EXISTEIX
-- RSP: PKG_ABM_AUTOR.MODIF_AUTOR  ERROR: EL AUTOR NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_AUTOR.MODIF_AUTOR(88888888,P,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_AUTOR  ERROR ! -1407: ORA-01407: cannot update ("APPS"."AUTOR"."IDPROD") to NULL

   PKG_ABM_AUTOR.MODIF_AUTOR(X,NULL,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_AUTOR  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.AUTOR_PRODUCTE_FK) violated - parent key not found

   PKG_ABM_AUTOR.MODIF_AUTOR(X,1111111,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + DESENVOLUPADOR)
-- RSP: PKG_ABM_MODIF_AUTOR  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.AUTOR__UN) violated
   
   PKG_ABM_AUTOR.MODIF_AUTOR(X,P,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- MODIFICACIO CORRECTA
-- RSP: OK
   PKG_ABM_AUTOR.MODIF_AUTOR(X,P,3,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- AUTOR    -- BAIXA AUTOR    
-------------------------------------------

--    PARAMETRES ENTRADA:  b_idautor

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA MODIF AUTOR';
   COMMIT;
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   COMMIT;
   SELECT IDAUTOR INTO X FROM AUTOR WHERE IDPROD = P AND rownum =1;
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI AUTOR NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_AUTOR  ERROR: EL PARAMETRE ENTRADA CODI AUTOR NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_AUTOR.BAIXA_AUTOR(NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: AUTOR NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_AUTOR  ERROR: AUTOR NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_AUTOR.BAIXA_AUTOR(888888888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA (ESBORRA DE LA TAULA AUTOR)
-- RSP: OK

   PKG_ABM_AUTOR.BAIXA_AUTOR(X,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- VIDEO     -- ALTA VIDEO
-------------------------------------------

-- PARAMETRES ENTRADA:  a_idproducte, a_ididioma, a_enllavideo

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('PROVA ABM VIDEO',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM VIDEO';
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.1','https://enlla_ABM VIDEO_1_1.1','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   COMMIT;
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   COMMIT;

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_VIDEO  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.VIDEO_PRODUCTE_FK) violated - parent key not found

   PKG_ABM_VIDEO.ALTA_VIDEO(1111111,1,'ENLLA 1',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_VIDEO  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."VIDEO"."ENLLAVIDEO")

   PKG_ABM_VIDEO.ALTA_VIDEO(P,1,NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ALTA CORRECTA
-- RSP: OK

   PKG_ABM_VIDEO.ALTA_VIDEO(P,1,'WWW.VIDEO P_1',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + IDIOMA)
-- RSP: PKG_ABM_ALTA_VIDEO  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.VIDEO__UN) violated

   PKG_ABM_VIDEO.ALTA_VIDEO(P,1,'WWW.VIDEO 1_8',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/


-------------------------------------------
-- VIDEO   -- MODIFICACIO VIDEO
-------------------------------------------

-- PARAMETRES ENTRADA:  m_idvideo, m_idproducte, m_ididioma, m_enllavideo

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM VIDEO';
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   SELECT IDVIDEO INTO X FROM VIDEO WHERE IDPRODUCTE = P AND IDIDIOMA = 1;
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI VIDEO NO POT SER NULL
-- RSP: PKG_ABM_MODIF_VIDEO  ERROR: EL PARAMETRE ENTRADA CODI VIDEO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_VIDEO.MODIF_VIDEO(NULL,3,8,'WWW.VIDEO 3_8',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL  VIDEO NO EXISTEIX
-- RSP: PKG_ABM_MODIF_VIDEO  ERROR: EL VIDEO NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_VIDEO.MODIF_VIDEO(333333,3,8,'WWW.VIDEO 3_8',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_VIDEO  ERROR ! -1407: ORA-01407: cannot update ("APPS"."VIDEO"."ENLLAVIDEO") to NULL

   PKG_ABM_VIDEO.MODIF_VIDEO(X,P,1,NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_VIDEO  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.VIDEO_IDIOMA_FK) violated - parent key not found

   PKG_ABM_VIDEO.MODIF_VIDEO(X,P,8888888,'WWW.VIDEO 3_8',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + IDIOMA)
-- RSP: PKG_ABM_MODIF_VIDEO  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.VIDEO__UN) violated

   PKG_ABM_VIDEO.ALTA_VIDEO(P,3,'WWW.VIDEO P_3',RSP);

   PKG_ABM_VIDEO.MODIF_VIDEO(X,P,3,'WWW.VIDEO 3_8',RSP);   
   DBMS_OUTPUT.PUT_LINE(RSP);

-- MODIFICACIO CORRECTA
-- RSP: OK

   PKG_ABM_VIDEO.MODIF_VIDEO(X,P,1,'WWW.VIDEO 3_11111',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- VIDEO     -- BAIXA VIDEO
-------------------------------------------

-- PARAMETRES ENTRADA:  b_idvideo

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM VIDEO';
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   SELECT IDVIDEO INTO X FROM VIDEO WHERE IDPRODUCTE = P AND IDIDIOMA = 1;
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI VIDEO NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_VIDEO  ERROR: EL PARAMETRE ENTRADA CODI VIDEO NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_VIDEO.BAIXA_VIDEO(NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: VIDEO NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_VIDEO  ERROR: EL VIDEO NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_VIDEO.BAIXA_VIDEO(11111111,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA (ESBORRA DE LA TAULA VIDEO )
-- RSP: OK

   PKG_ABM_VIDEO.BAIXA_VIDEO(X,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- PREUS         -- ALTA PREUS
-------------------------------------------

-- PARAMETRES ENTRADA:  a_idproducte, a_idpais, a_preuaplic


DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDCATEGORIA INTO N FROM CATEGORIA WHERE NOMCATEGORIA='PROVES';
   PKG_ABM_APLICACIONS.ALTA_APLICACIO ('PROVA ABM PREUS',N,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   COMMIT;
   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM PREUS';
   PKG_ABM_PRODUCTE.ALTA_PRODUCTE(N,1,'1.1','https://enlla_ABM PRESU_1_1.1','3,1M', '320 x 480 pixels','01/01/2012',RSP);
   COMMIT;
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   COMMIT;

-- ALTA CORRECTA
-- RSP: OK
 
   PKG_ABM_PREUS.ALTA_PREUS (P,1,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_ALTA_PREUS  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.PREUS_PRODUCTE_FK) violated - parent key not found

   PKG_ABM_PREUS.ALTA_PREUS (88888,1,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_ALTA_PREUS  ERROR: HI VALORS QUE NO PODEN SER NULL -1400: ORA-01400: cannot insert NULL into ("APPS"."PREUS"."PREUAPLIC")

   PKG_ABM_PREUS.ALTA_PREUS (P,1,NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + PAIS)
-- RSP: PKG_ABM_ALTA_PREUS  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.PREUS__UN) violated

   PKG_ABM_PREUS.ALTA_PREUS (P,2,777,RSP);
   COMMIT;
   PKG_ABM_PREUS.ALTA_PREUS (P,2,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- PREUS    -- MODIFICACIO PREUS
-------------------------------------------

-- PARAMETRES ENTRADA:  m_idpreus, m_idproducte, m_idpais, m_preuaplic

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM PREUS';
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   SELECT IDPREUS INTO X FROM PREUS WHERE IDPRODUCTE = P AND IDPAIS = 1;
   COMMIT;

-- ERROR: EL PARAMETRE ENTRADA CODI PREUS NO POT SER NULL
-- RSP: PKG_ABM_MODIF_PREUS  ERROR: EL PARAMETRE ENTRADA CODI PREUS NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_PREUS.MODIF_PREUS (NULL,P,1,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: QUE EL  PREU NO EXISTEIX
-- RSP: PKG_ABM_MODIF_PREUS  ERROR: EL PREU NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_PREUS.MODIF_PREUS (855555555,P,1,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: HI VALORS QUE NO PODEN SER NULL
-- RSP: PKG_ABM_MODIF_PREUS  ERROR ! -1407: ORA-01407: cannot update ("APPS"."PREUS"."PREUAPLIC") to NULL

   PKG_ABM_PREUS.MODIF_PREUS (X,P,1,NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: CLAU FORANA NO EXISTENT
-- RSP: PKG_ABM_MODIF_PREUS  ERROR: CLAU FORANA NO EXISTENT -2291: ORA-02291: integrity constraint (APPS.PREUS_PAIS_FK) violated - parent key not found

   PKG_ABM_PREUS.MODIF_PREUS (X,P,888888,888,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: (CLAU UNICA: PRODUCTE + PAIS)
-- RSP: PKG_ABM_MODIF_PREUS  ERROR: CLAU UNICA, NO POT HAVER-HI DUPLICATS -1: ORA-00001: unique constraint (APPS.PREUS__UN) violated

   PKG_ABM_PREUS.MODIF_PREUS (X,P,2,8,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- MODIFICACIO CORRECTA
-- RSP: OK

   PKG_ABM_PREUS.MODIF_PREUS (X,P,1,81111,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

-------------------------------------------
-- PREUS      -- BAIXA PREUS
-------------------------------------------

-- PARAMETRES ENTRADA:  b_idpreus   

DECLARE

   RSP VARCHAR2(500);
   N NUMBER;
   P NUMBER;
   X NUMBER;

BEGIN

-- ERROR: EL PARAMETRE ENTRADA CODI PREUS NO POT SER NULL
-- RSP: PKG_ABM_BAIXA_PREUS  ERROR: EL PARAMETRE ENTRADA CODI PREUS NO POT SER NULL  1: User-Defined Exception

   PKG_ABM_PREUS.BAIXA_PREUS(NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- ERROR: PREU NO EXISTEIX
-- RSP: PKG_ABM_BAIXA_PREUS  ERROR: EL PREU NO EXISTEIX 100: ORA-01403: no data found

   PKG_ABM_PREUS.BAIXA_PREUS(8555555,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

-- BAIXA CORRECTA (ESBORRA DE LA TAULA PREUS)
-- RSP: OK

   SELECT IDAPLICACIO INTO N FROM APLICACIO WHERE nomapli = 'PROVA ABM PREUS';
   SELECT CODIPRODUCTE INTO P FROM PRODUCTE WHERE IDAPLIC = N;	
   SELECT IDPREUS INTO X FROM PREUS WHERE IDPRODUCTE = P AND IDPAIS = 1;
   COMMIT;

   PKG_ABM_PREUS.BAIXA_PREUS(X,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
spool OFF
