/************************************************************************************
   Alumna: Merc Jorquera Teixid
   Base de dades: Oracle 11g
   TFC: DESCARREGA D'APLICACIONS PER A MBILS INTEL.LIGENTS
   SCRIPT: 12-JOC_PROVES_CONSULTES.sql
************************************************************************************/

----------------------------------
-- JOC DE PROVES DE LES CONSULTES
----------------------------------
set serveroutput on size 1000000;
set echo on
spool JOC_PROVES_CONSULTES.log

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_1
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        El llistat de tots els desenvolupadors dun pas donat amb
                        totes les seves dades, incloent el nmero daplicacions
                        diferents publicades, entenent com a aplicacions: 
                        APLICACIO + SSOO
   PARAMETRES ENTRADA:  c_pais
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:              ERROR: EL PARAMETRE ENTRADA NO POT SER NULL 
                        ERROR: EL PAIS NO EXISTEIX
   EXEMPLE DE CRIDA:    CONSULTA_1(1,rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- PAIS 1 : ESPANYA
consulta_1(1, rsp);
END;
/

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_2
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        El llistat de totes les aplicacions actives i de les seves dades
                        principals, ordenat pel nmero total de descrregues que
                        han tingut fins al moment a nivell mundial, 
                        entenent com aplicacions: APLICACIO + SSOO + VERSIO
   PARAMETRES ENTRADA:  SENSE PARAMETRES
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   EXEMPLE DE CRIDA:    CONSULTA_2(rsp);
********************************************************************************************/

DECLARE 
rsp varchar2(250);
BEGIN
consulta_2(rsp);
END;
/

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_3
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        Donada una aplicaci i un any concret: el llistat de tots els
                        pasos on sha descarregat aquell any, aix com el nmero
                        de descrregues que ha tingut a cada pas, 
                        entenent com aplicacions:  APLICACIO (sense tenir en compte
                        ni el Sistema Operatiu ni la versi)
   PARAMETRES ENTRADA:  c_idaplicacio, c_any
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   EXEMPLE DE CRIDA:    CONSULTA_3(3,2012,rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- APLICACIO 1 : MAHJONG 3D
-- ANY:          2012 
consulta_3(1,2012,rsp);
END;
/

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_4
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        Donat un usuari final (identificat pel seu nmero de telfon),
                        el llistat de tota la seva activitat de descrregues a la
                        plataforma, incloent data, aplicaci descarregada, preu que
                        va pagar, etc..., entenent com a aplicacions: 
                        APLICACIO + SSOO + VERSIO
   PARAMETRES ENTRADA:  c_ntel
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:              ERROR: EL PARAMETRE ENTRADA NO POT SER NULL 
                        ERROR: EL TELEFON NO EXISTEIX    
                        ERROR: EL NUMERO DE DIGITS DEL TELEFON ES INCORRECTE  
                        ERROR: l'USUARI D'AQUEST TELEFON NO TE DESCARREGUES
   EXEMPLE DE CRIDA:    CONSULTA_4('649665511',rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- N TELEFON: 649586974  USUARI: LEONOR TEMPRADO	GARCIA
consulta_4('649586974',rsp);
END;
/

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_5
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        Donat un any concret el llistat dels 20 usuaris que ms
                        diners shan gastat en aplicacions mbils, ordenat de ms a menys, 
                        entenent com aplicacions:  APLICACIO + SSOO + VERSIO)
   PARAMETRES ENTRADA:  c_any
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:              ERROR: EL PARAMETRE ENTRADA NO POT SER NULL 
                        ERROR: NO HI HA CAP DESCARREGA EN AQUEST ANY                       
   EXEMPLE DE CRIDA:    CONSULTA_5(2012,rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- ANY : 2012
consulta_5('2012',rsp);
END;
/

/********************************************************************************************
   PROCEDIMENT:         CONSULTA_6
   DESCRIPCI:          LLISTA LES DADES CORRESPONENTS A:
                        Donada una determinada categoria, el llistat de les aplicacions actives
                        per descarregar relacionadees amb aquesta categoria, entenent 
                        com aplicacions: APLICACIO + SSOO + VERSIO
   PARAMETRES ENTRADA:  c_idcategoria
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:              ERROR: EL PARAMETRE ENTRADA NO POT SER NULL 
                        ERROR: LA CATEGORIA c_idcategoria  NO EXISTEIX
                        ERROR: NO HI HA CAP PRODUCTE ACTIU D'AQUESTA CATEGORIA                             
   EXEMPLE DE CRIDA:    CONSULTA_6('1',rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- CATEGORIA :1  JOCS
consulta_6(1,rsp);
END;
/
spool off