/************************************************************************************
   Alumna: Merc Jorquera Teixid
   Base de dades: Oracle 11g
   TFC: DESCARREGA D'APLICACIONS PER A MBILS INTEL.LIGENTS
   SCRIPT: 13-JOC_PROVES_ESTADISTIQUES.sql
************************************************************************************/

----------------------------------------
-- JOC DE PROVES DE LES ESTADISTIQUES
----------------------------------------
SET SERVEROUTPUT ON;
set echo on
spool JOC_PROVES_ESTADISTIQUES.log

/********************************************************************************************
   PROCEDIMENT:          MODUL_EST_12
   DESCRIPCI:           ACTUALITZA LES DADES CORRESPONENTS AL TOTAL DE DESCARREGUES
                         DE LA PLATAFORMA FINS A LA DATA I EL NMERO TOTAL D'EUROS 
                         GENERATS EN DESCARREGUES A LA PLATAFORMA FINS ARA MATEIX.
   PARAMETRES ENTRADA:   SENSE PARAMETRES
   PARAMETRES SORTIDA:   rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   EXEMPLE DE CRIDA:     MODUL_EST_12(rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN
-- SENSE PARAMETRES D'ENTRADA
MODUL_EST_12(rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_12;
/

-- ES FAN 12 MES DESCARREGUES A L'ANY 2012
DECLARE 
rsp varchar2(250);
BEGIN
ALTA_DESCARREGA(	105	,	1	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	105	,	2	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	105	,	3	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	104	,	4	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	104	,	5	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	104	,	6	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	104	,	7	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	90	,	8	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	90	,	9	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	103	,	10	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	103	,	11	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	103	,	12	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	103	,	13	,	2	,	'01/07/2012'	,RSP);
COMMIT;
END; 
/

DECLARE 
rsp varchar2(250);
BEGIN
-- SENSE PARAMETRES D'ENTRADA
MODUL_EST_12(rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_12;
/

/********************************************************************************************
   PROCEDIMENT:         MODUL_EST_345
   DESCRIPCI:          ACTUALITZA LES DADES CORRESPONENTS A:
                        - Donat un any concret el nmero mig daplicacions
                          descarregades per un usuari
                        - Donat un any concret, el desenvolupador que tingui el
                          mxim nmero de descrregues (sumant totes les descrregues
                          de totes les seves aplicacions que shagin realitzat aquell any),
                          aix com aquest nmero.  
                        - Donat un any concret, laplicaci que ms diners ha recaudat
                          en descrregues aix com el/s seu/s desenvolupador/s.  
   PARAMETRES ENTRADA:   e_any
   PARAMETRES SORTIDA:   rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:               ERROR: EL PARAMETRE D'ENTRADA NO POT SER NULL
                         ERROR: NO EXISTEIXIN DESCARREGUES D'AQUEST ANY: e_anyo
   EXEMPLE DE CRIDA:     MODUL_EST_345(2012,rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN

-- ANY : 2011

MODUL_EST_345(2011,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_345 WHERE ANYO = 2011;
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_345(2012,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_345 WHERE ANYO = 2012;
/

--PROVA ESTADISTICA 3

-- ES FAN 13 MES DESCARREGUES A L'ANY 2012
DECLARE 
rsp varchar2(250);
BEGIN
ALTA_DESCARREGA(	106	,	1	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	2	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	3	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	4	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	5	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	6	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	108	,	7	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	102	,	8	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	103	,	9	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	104	,	10	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	105	,	11	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	12	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	107	,	13	,	2	,	'01/07/2012'	,RSP);
COMMIT;

-- ES DONA D'ALTA UN ALTRE USUARI ACTIU
   ALTA_USUARI('JOHN','TEST','TEST','US985TEST','680000222','AV. NEW YORK, 333',16,'US040',6,'JTT@hotmail.com',9, '01/01/2011',RSP);
   COMMIT;
   
END; 
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_345(2012,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_345 WHERE ANYO = 2012;
/

-- PROVA ESTADISTICA 4

-- ES FAN 26 MES DESCARREGUES A L'ANY 2012 DEL DESENVOLUPADOR 6
DECLARE 
rsp varchar2(250);
BEGIN
ALTA_DESCARREGA(	106	,	1	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	2	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	3	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	4	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	5	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	6	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	7	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	8	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	9	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	10	,	3	,	'01/07/2012'	,RSP);

ALTA_DESCARREGA(	106	,	11	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	12	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	13	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	106	,	14	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	15	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	16	,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	17	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	18	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	19	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	20	,	3	,	'01/07/2012'	,RSP);

ALTA_DESCARREGA(	97	,	21	,	4	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	22	,	1	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	23	,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	24    ,	2	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	25    ,	3	,	'01/07/2012'	,RSP);
ALTA_DESCARREGA(	97	,	26	,	4	,	'01/07/2012'	,RSP);

COMMIT;

END; 
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_345(2012,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_345 WHERE ANYO = 2012;
/


-- PROVA ESTADISTICA 5

DECLARE 
rsp varchar2(250);
X NUMBER;
BEGIN

--ES CANVIA EL PREU DE PRODUCTE 99

   SELECT IDPREUS INTO X FROM PREUS WHERE IDPRODUCTE = 99 AND IDPAIS = 7;
   COMMIT;

   PKG_ABM_PREUS.MODIF_PREUS (X,99,7,20000,RSP);

-- S'AFEGEIXEN DOS DESENVOLUPADORS MES COM AUTORS DEL PRODUCTE
   PKG_ABM_AUTOR.ALTA_AUTOR(99,1,RSP);
   PKG_ABM_AUTOR.ALTA_AUTOR(99,10,RSP);
   COMMIT;	

-- ES FAN 2 DESCARREGUES MES A L'ANY 2012 DEL DESENVOLUPADOR 13

ALTA_DESCARREGA(	99	,	22	,	2	,	'05/07/2012'	,RSP);
ALTA_DESCARREGA(	99	,	23	,	3	,	'05/07/2012'	,RSP);

COMMIT;

   PKG_ABM_PREUS.MODIF_PREUS (X,99,7,20,RSP);


COMMIT;

END; 
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_345(2012,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_345 WHERE ANYO = 2012;
/


/********************************************************************************************
   PROCEDIMENT:         MODUL_EST_678
   DESCRIPCI:          ACTUALITZA LES DADES CORRESPONENTS A:
                        - Donat un any concret i un pas: el nmero dusuaris
                          diferents que han fet com a mnim una descrrega.
                        - Donat un any concret i un pas: el ingressos totals que han
                          generat els usuaris registrats en aquell pas en descrregues
                          daplicacions
                        - Donat un any concret i un pas: el nmero daplicacions
                          diferents descarregades com a mnim una vegada.  
   PARAMETRES ENTRADA:  e_any, e_pais
   PARAMETRES SORTIDA:  rsp
   RETORNA:             'OK' SI L'EXECUCI HA ACABAT CORRECTAMENT 
                        'ERROR: tipus d'error' SI HA FRACASAT
   ERRORS:               ERROR: ELS PARAMETRES D'ENTRADA NO PODEN SER NULL
                         ERROR: NO EXISTEIXIN DESCARREGUES D'AQUEST ANY: e_anyo  
                         ERROR: EL PAIS e_pais NO EXISTEIX                         
   EXEMPLE DE CRIDA:     MODUL_EST_678(2012,1,rsp);
********************************************************************************************/
DECLARE 
rsp varchar2(250);
BEGIN

-- ANY : 2011
-- PAIS: 6   ESTATS UNITS

MODUL_EST_678(2011,6,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_678 WHERE ANYO = 2011 AND IDPAIS = 6;
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_678(2012,6,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_678 WHERE ANYO = 2012 AND IDPAIS = 6;
/

-- ES FAN 13 DESCARREGUES  MES A L'ANY 2012
DECLARE 
rsp varchar2(250);
BEGIN
ALTA_DESCARREGA(	99	,	19	,	2	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	99	,	20	,	3	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	99	,	21	,	4	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	107	,	19	,	1	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	107	,	20	,	2	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	107	,	21	,	3	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	106	,	19	,	4	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	106   ,	20	,	1	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	106	,	21	,	2	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	105	,	19	,	3	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	105	,	20	,	4	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	105	,	21	,	1	,	'01/08/2012'	,RSP);
ALTA_DESCARREGA(	104	,	19	,	2	,	'01/08/2012'	,RSP);
COMMIT;

END; 
/

-- ANY : 2012
DECLARE 
rsp varchar2(250);
BEGIN
MODUL_EST_678(2012,6,rsp);
COMMIT;
END;
/
SELECT * FROM ESTADISTICA_678 WHERE ANYO = 2012 AND IDPAIS = 6;
/

spool off